use crate::bootboot::{BOOTBOOT, BOOTBOOT_FB};
use crate::util::get_bootboot;

use BOOTBOOT_FB as FB;

pub fn put_pixel(x: u32, y: u32, color: u32) -> () {
    let boot: BOOTBOOT = get_bootboot();
    let ptr: u64 = FB + (boot.fb_scanline * y) as u64 + (x * 4) as u64;
    unsafe { *(ptr as *mut u32) = color };
}

pub fn draw_rect(x: u32, y: u32, width: u32, height: u32, color: u32) -> () {
    let boot: BOOTBOOT = get_bootboot();
    for i in y..(y + height)
    {
        let addr: u64 = FB + (boot.fb_scanline * i) as u64 + (x * 4) as u64;
        for ptr in (addr..(addr + (width*4) as u64)).step_by(4)
        {
            unsafe { *(ptr as *mut u32) = color };
        }
    }
}

pub fn clear(color: u32) -> () {
    let boot: BOOTBOOT = get_bootboot();
    draw_rect(0, 0, boot.fb_width, boot.fb_height, color)
}